Debian Bug report logs - #402482
busybox gunzip / zcat fail to decompress validly gzipped files

version graph

Package: busybox-udeb; Maintainer for busybox-udeb is Debian Install System Team <debian-boot@lists.debian.org>; Source for busybox-udeb is src:busybox.

Reported by: Steve McIntyre <steve@einval.com>

Date: Sun, 10 Dec 2006 19:03:11 UTC

Severity: serious

Tags: etch-ignore

Found in version busybox/1:1.1.3-3

Fixed in version 1:1.9.2-1

Done: Thijs Kinkhorst <thijs@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to Steve McIntyre <steve@einval.com>:
New Bug report received and forwarded. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Steve McIntyre <steve@einval.com>
To: submit@bugs.debian.org
Subject: busybox gunzip / zcat fail to decompress validly gzipped files
Date: Sun, 10 Dec 2006 18:56:28 +0000
[Message part 1 (text/plain, inline)]
Package: busybox-udeb
Version: 1:1.1.3-3
Severity: serious

Busybox's gunzip/zcat code does not correctly compress a validly
compressed file (in this case amd64.gz):

# gzip -t (test) says it's ok:
tack:~$ gzip -t -v amd64.gz 
amd64.gz:        OK

# and the normal system versions of gunzip and zcat cope:
tack:~$ gunzip -cd < amd64.gz | wc -l
5151
tack:~$ zcat amd64.gz | wc -l
5151

# But the busybox versions don't:
tack:~$ ./debian/d-i/busybox/bin/gunzip -cd < amd64.gz | wc -l
29
tack:~$ ./debian/d-i/busybox/bin/zcat amd64.gz | wc -l
29

The file is created by concatenating several gzipped chunks of data
together, which documentation says is a valid thing to do. The busybox
tools are being confused by this, and only decompressing the first
such block in the file. This just caused a set of daily builds of d-i
CDs to break, hence I'm marking this serious.

-- 
Steve McIntyre, Cambridge, UK.                                steve@einval.com
"C++ ate my sanity" -- Jon Rabone
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to Frans Pop <elendil@planet.nl>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 402482@bugs.debian.org (full text, mbox):

From: Frans Pop <elendil@planet.nl>
To: 402482@bugs.debian.org
Subject: Re: Bug#402482: busybox gunzip / zcat fail to decompress validly gzipped files
Date: Sun, 10 Dec 2006 20:38:18 +0100
[Message part 1 (text/plain, inline)]
On Sunday 10 December 2006 19:56, Steve McIntyre wrote:
> Busybox's gunzip/zcat code does not correctly compress a validly
> compressed file (in this case amd64.gz):

The same issue was seem on i386 and should be arch independent.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 402482@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: 402482@bugs.debian.org
Subject: RC?
Date: Mon, 11 Dec 2006 18:26:20 -0500
[Message part 1 (text/plain, inline)]
I don't belive that this bug is actually RC: There's a workaround for
the problem in debian-cd, and the bug's not causing any other problems
that I know of.

-- 
see shy jo, fairly heavy user of gzip >> file.gz
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to Steve McIntyre <steve@einval.com>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #20 received at 402482@bugs.debian.org (full text, mbox):

From: Steve McIntyre <steve@einval.com>
To: 402482@bugs.debian.org
Subject: Re: RC?
Date: Tue, 12 Dec 2006 01:01:46 +0000
[Message part 1 (text/plain, inline)]
Joey wrote:
>I don't belive that this bug is actually RC: There's a workaround for
>the problem in debian-cd, and the bug's not causing any other
>problems that I know of.

I'm happy for this to be tagged etch-ignore, but it can potentially
lead to data loss so I think it should stay as serious in the long
run....

-- 
Steve McIntyre, Cambridge, UK.                                steve@einval.com
"...In the UNIX world, people tend to interpret `non-technical user'
 as meaning someone who's only ever written one device driver." -- Daniel Pead
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to "peter green" <peter_m_green@hotmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #25 received at 402482@bugs.debian.org (full text, mbox):

From: "peter green" <peter_m_green@hotmail.com>
To: 402482@bugs.debian.org
Subject: tried to reproduce and failed.
Date: Sun, 17 Dec 2006 02:35:33 +0000
i've tried to reproduce this bug but failed

btw in the process of trying this i discovered that busybox --install 
doesn't seem to work either i had to manually copy busybox and make a 
symlink for this test.

debian:~/busyboxinstall# cp /bin/busybox .
debian:~/busyboxinstall# ln -s gunzip busybox
ln: creating symbolic link `busybox' to `gunzip': File exists
debian:~/busyboxinstall# ln -s busybox gunzip
debian:~/busyboxinstall# ./gunzip
gunzip: compressed data not read from terminal.  Use -f to force it.
debian:~/busyboxinstall# echo foo | foo.txt
bash: foo.txt: command not found
debian:~/busyboxinstall# echo foo > foo.txt
debian:~/busyboxinstall# echo bar > foo.txt
debian:~/busyboxinstall# echo foo > foo.txt
debian:~/busyboxinstall# echo foo > bar.txt
debian:~/busyboxinstall# gzip foo.txt
debian:~/busyboxinstall# gzip bar.txt
debian:~/busyboxinstall# cat foo.txt.gz bar.txt.gz > baz.txt.gz
debian:~/busyboxinstall# gunzip baz.txt.gz
debian:~/busyboxinstall# cat baz.txt
foo
foo
debian:~/busyboxinstall# cat foo.txt.gz bar.txt.gz > baz.txt.gz
debian:~/busyboxinstall# ./gunzip baz.txt.gz
debian:~/busyboxinstall# cat baz.txt
foo
foo
debian:~/busyboxinstall# ls -l
total 428
-rw-r--r-- 1 root root     32 2006-12-17 02:30 bar.txt.gz
-rw-r--r-- 1 root root      8 2006-12-17 02:31 baz.txt
-rwxr-xr-x 1 root root 418112 2006-12-17 02:29 busybox
-rw-r--r-- 1 root root     32 2006-12-17 02:30 foo.txt.gz
lrwxrwxrwx 1 root root      7 2006-12-17 02:29 gunzip -> busybox
debian:~/busyboxinstall#

_________________________________________________________________
Visit MSN Holiday Challenge for your chance to win up to $50,000 in Holiday 
cash from MSN today!  
http://www.msnholidaychallenge.com/index.aspx?ocid=tagline&locale=en-us




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to Andreas Barth <aba@not.so.argh.org>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #30 received at 402482@bugs.debian.org (full text, mbox):

From: Andreas Barth <aba@not.so.argh.org>
To: Steve McIntyre <steve@einval.com>
Cc: 402482@bugs.debian.org
Subject: Re: RC?
Date: Wed, 20 Dec 2006 08:35:40 +0100
severity 402482 important
thanks

* Steve McIntyre (steve@einval.com) [061211 17:02]:
> Joey wrote:
> >I don't belive that this bug is actually RC: There's a workaround for
> >the problem in debian-cd, and the bug's not causing any other
> >problems that I know of.
> 
> I'm happy for this to be tagged etch-ignore, but it can potentially
> lead to data loss so I think it should stay as serious in the long
> run....

I have yet to see the dataloss. Anyways, bugs being important doesn't
mean they are not allowed to be fixed (and I would let such an fix still
to Etch currently), but I don't think we should wait on the fix. So I'm
downgrading to important.


Cheers,
Andi
-- 
  http://home.arcor.de/andreas-barth/



Severity set to `important' from `serious' Request was from Andreas Barth <aba@not.so.argh.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to Frans Pop <elendil@planet.nl>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #37 received at 402482@bugs.debian.org (full text, mbox):

From: Frans Pop <elendil@planet.nl>
To: Andreas Barth <aba@not.so.argh.org>, 402482@bugs.debian.org
Subject: Re: Bug#402482: RC?
Date: Wed, 20 Dec 2006 14:41:29 +0100
[Message part 1 (text/plain, inline)]
On Wednesday 20 December 2006 08:35, Andreas Barth wrote:
> I have yet to see the dataloss. Anyways, bugs being important doesn't
> mean they are not allowed to be fixed (and I would let such an fix
> still to Etch currently), but I don't think we should wait on the fix.
> So I'm downgrading to important.

The dataloss is there, though not in the conventional sense: the file 
itself is correct, but using busybox zcat or gunzip only part of it is 
extracted so from a user PoV data is "lost".

Then why not leave it at RC and tag it etchignore. IMO that would better 
fit this issue.

Cheers,
FJP
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to Andreas Barth <aba@not.so.argh.org>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #42 received at 402482@bugs.debian.org (full text, mbox):

From: Andreas Barth <aba@not.so.argh.org>
To: Frans Pop <elendil@planet.nl>
Cc: 402482@bugs.debian.org
Subject: Re: Bug#402482: RC?
Date: Wed, 20 Dec 2006 14:45:38 +0100
* Frans Pop (elendil@planet.nl) [061220 14:42]:
> On Wednesday 20 December 2006 08:35, Andreas Barth wrote:
> > I have yet to see the dataloss. Anyways, bugs being important doesn't
> > mean they are not allowed to be fixed (and I would let such an fix
> > still to Etch currently), but I don't think we should wait on the fix.
> > So I'm downgrading to important.
> 
> The dataloss is there, though not in the conventional sense: the file 
> itself is correct, but using busybox zcat or gunzip only part of it is 
> extracted so from a user PoV data is "lost".
> 
> Then why not leave it at RC and tag it etchignore. IMO that would better 
> fit this issue.

If you want, you can do it (IOW, this is a direct approval of using
etch-ignore by you in this case).


Cheers,
Andi
-- 
  http://home.arcor.de/andreas-barth/



Severity set to `serious' from `important' Request was from Frans Pop <elendil@planet.nl> to control@bugs.debian.org. Full text and rfc822 format available.

Tags added: etch-ignore Request was from Frans Pop <elendil@planet.nl> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #51 received at 402482@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: Frans Pop <elendil@planet.nl>, 402482@bugs.debian.org
Cc: Andreas Barth <aba@not.so.argh.org>
Subject: Re: Bug#402482: RC?
Date: Wed, 20 Dec 2006 17:46:48 -0800
On Wed, Dec 20, 2006 at 02:41:29PM +0100, Frans Pop wrote:
> On Wednesday 20 December 2006 08:35, Andreas Barth wrote:
> > I have yet to see the dataloss. Anyways, bugs being important doesn't
> > mean they are not allowed to be fixed (and I would let such an fix
> > still to Etch currently), but I don't think we should wait on the fix.
> > So I'm downgrading to important.

> The dataloss is there, though not in the conventional sense: the file 
> itself is correct, but using busybox zcat or gunzip only part of it is 
> extracted so from a user PoV data is "lost".

No, that's not the standard for data loss, and this does not qualify as a
grave bug on those grounds.  No data is *lost* just because busybox gunzip
can't get to it.

Nor is the package "unusable or mostly so"; clearly the package is usable,
it's been stated in the bug log that this bug no longer impacts d-i, which
is using it.

You could argue that the package is "unfit for release" (=> sev: serious),
but then I don't see how that's consistent with asking for an etch-ignore
tag.  If it's ignorable for etch, I don't see why it wouldn't also be
ignorable for lenny if it didn't get fixed in time.

-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
vorlon@debian.org                                   http://www.debian.org/



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to Frans Pop <elendil@planet.nl>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #56 received at 402482@bugs.debian.org (full text, mbox):

From: Frans Pop <elendil@planet.nl>
To: Steve Langasek <vorlon@debian.org>, 402482@bugs.debian.org
Subject: Re: Bug#402482: RC?
Date: Thu, 21 Dec 2006 15:12:29 +0100
[Message part 1 (text/plain, inline)]
On Thursday 21 December 2006 02:46, Steve Langasek wrote:
> You could argue that the package is "unfit for release" (=> sev:
> serious), but then I don't see how that's consistent with asking for an
> etch-ignore tag.  If it's ignorable for etch, I don't see why it
> wouldn't also be ignorable for lenny if it didn't get fixed in time.

It has severity serious, so we agree about that.
The reason it is ignorable for Etch is IMO that the problem has already 
been in busybox for a long time and that is was only discovered very 
shortly before the release. These facts make it unrealistic to delay the 
release for the issue.
However, that does not mean it should also be ignored for a release that 
is 1.5 years away. Keeping it at serious with tag etch-ignore basically 
means "please fix asap, if possible even in time for Etch".

The issue is serious as people may not always know exactly what to expect 
when extracting data from a zipped file and thus may not know they are 
missing anything.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #61 received at 402482@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: control@bugs.debian.org, 402482@bugs.debian.org
Subject: Re: busybox gunzip / zcat fail to decompress validly gzipped files
Date: Sun, 20 May 2007 19:54:29 +0200
# etch is out, removing ignore tag.
tags 402482 -etch-ignore
thanks

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/



Tags removed: etch-ignore Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Sun, 20 May 2007 17:57:11 GMT) Full text and rfc822 format available.

Tags added: etch-ignore Request was from Steve Langasek <vorlon@debian.org> to control@bugs.debian.org. (Sun, 20 May 2007 22:27:01 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to Denys Vlasenko <vda.linux@googlemail.com>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #70 received at 402482@bugs.debian.org (full text, mbox):

From: Denys Vlasenko <vda.linux@googlemail.com>
To: 402482@bugs.debian.org
Subject: testcases of busybox gzip misbehaving
Date: Thu, 4 Oct 2007 14:05:44 +0100
Please send testcases where GNU gzip works and busybox gzip doesnt - to me.
I will try to fix those.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #75 received at 402482@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Denys Vlasenko <vda.linux@googlemail.com>, 402482@bugs.debian.org
Subject: Re: Bug#402482: testcases of busybox gzip misbehaving
Date: Thu, 4 Oct 2007 16:03:32 -0400
[Message part 1 (text/plain, inline)]
Denys Vlasenko wrote:
> Please send testcases where GNU gzip works and busybox gzip doesnt - to me.
> I will try to fix those.

It's easy enough to reproduce for me:

joey@kodama:~>echo foo | gzip > test.gz
joey@kodama:~>echo bar | gzip >> test.gz
joey@kodama:~>gunzip < test.gz 
foo
bar
joey@kodama:~>busybox gunzip < test.gz
foo
joey@kodama:~>

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#402482; Package busybox-udeb. Full text and rfc822 format available.

Acknowledgement sent to Denys Vlasenko <vda.linux@googlemail.com>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. Full text and rfc822 format available.

Message #80 received at 402482@bugs.debian.org (full text, mbox):

From: Denys Vlasenko <vda.linux@googlemail.com>
To: 402482@bugs.debian.org
Subject: Fixed in busybox svn
Date: Fri, 5 Oct 2007 20:27:11 +0100
[Message part 1 (text/plain, inline)]
Fixed in busybox svn, planned to be in 1.8.0.

Attached patch should fix it for 1.7.2
(untested on 1.7.2, run-tested on svn head)
--
vda
[gunzip_concat_loic.diff.bz2 (application/x-bzip2, attachment)]

Reply sent to Thijs Kinkhorst <thijs@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Steve McIntyre <steve@einval.com>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #85 received at 402482-done@bugs.debian.org (full text, mbox):

From: Thijs Kinkhorst <thijs@debian.org>
To: 402482-done@bugs.debian.org
Subject: fixed in 1:1.9.2-1
Date: Mon, 24 Mar 2008 12:59:50 +0100
[Message part 1 (text/plain, inline)]
Version: 1:1.9.2-1

Hi,

I've confirmed this bug was indeed fixed in the recent upload of th 1.9.x 
series.


Thijs
[Message part 2 (application/pgp-signature, inline)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 16 Mar 2009 10:13:05 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 10:39:31 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.